<?php

if(!defined('_PS_VERSION_')
	OR !defined('_CAN_LOAD_FILES_')
)
{
	exit;
}

class ecm_prestaparcer extends Module
{
	/* @var boolean error */
	protected $_errors = false;

	public
	function __construct()
	{
		$this->name = 'ecm_prestaparcer';
		$this->tab = 'content_management';
		$this->version = '0.9';
		$this->author = 'Elcommerce';
		$this->ps_versions_compliancy = array('min'=> '1.5','max'=> '1.6.10');
		$this->need_instance = 1;
		$this->module_key = "";
		$this->bootstrap = true;

		parent::__construct();

		$this->displayName = $this->l('Presta parser');
		$this->description = $this->l('Content parser for Prestashop');
	}

	public
	function install()
	{
		$sql = array();
		$table = _DB_PREFIX_."image";
		$sql[]="ALTER TABLE $table ADD tmpfile VARCHAR(256)";

		if(!parent::install()
			OR !$this->registerHook('displayAdminProductsExtra')
			OR !$this->runSql($sql)
		){
			return FALSE;
		}

		return TRUE;
	}
	public
	function uninstall()
	{
		$sql = array();
		$table = _DB_PREFIX_."image";
		$sql[]="ALTER TABLE $table DROP tmpfile";

		if(!parent::uninstall()
			OR !$this->runSql($sql)
		){
			return FALSE;
		}
		return TRUE;
	}

	public
	function runSql($sql)
	{
		foreach($sql as $s)
		{
			if(!Db::getInstance()->Execute($s))
			{
				return FALSE;
			}
		}
		return TRUE;
	}

	public
	function hookDisplayAdminProductsExtra($params)
	{
		$id_product = Tools::getValue('id_product');
		//p ($id_product);

		$lang = (int)Configuration::get('PS_LANG_DEFAULT');
		$table = _DB_PREFIX_."product";
		$table_lang = _DB_PREFIX_."product_lang";
		$sql = "
			SELECT p.`id_product`, p.`ean13`, p.`reference`,
			pl.`name`, pl.`description_short`, pl.`description` `description_full`
			FROM `$table` p
			LEFT JOIN `$table_lang` pl ON p.`id_product` = pl.`id_product` AND  pl.`id_lang` = '$lang'
			WHERE p.`id_product` = '$id_product'
			";
		$result = Db::getInstance()->ExecuteS($sql);
		$ymprod = $result[0];
		//p ($ymprod);
		$this->context->smarty->assign(
			array(
				'ymprod'=> $ymprod,
				'dir'   => $this->_path,
				)
			);
		//include ('js/ecm_ymp15.js');
		return $this->display(__FILE__, 'views/admin/ecm_prestaparcer5.tpl');
	}
	private
	function _displayabout(){
		$html = '
		<div class="panel">
			<div class="panel-heading">
				<i class="icon-envelope"></i> ' . $this->l('Информация') . '
			</div>
			<div id="dev_div">
				<span><b>' . $this->l('Версия') . ':</b> ' . $this->version . '</span><br>
				<span><b>' . $this->l('Разработчик') . ':</b> <a class="link" href="mailto:support@elcommerce.com.ua" target="_blank">Elcommerce</a>
				<span><b>' . $this->l('Описание') . ':</b> <a class="link" href="http://elcommerce.com.ua" target="_blank">http://elcommerce.com.ua</a><br><br>
				<p style="text-align:center"><a href="http://elcommerce.com.ua/"><img src="http://elcommerce.com.ua/img/m/logo.png" alt="Электронный учет коммерческой деятельности" /></a>
			</div>
		</div>
		';
		return $html;
	}

	public
	function getContent(){
		$this->_html = '';
		$this->_html .= $this->postProcess();
		$this->_html .= $this->renderForm();
		$this->_html .= $this->_displayabout();
		return $this->_html;
	}

	public
	function postProcess(){
		if(Tools::isSubmit('submit_parcer')){
			Configuration::UpdateValue('PARSER', Tools::GetValue('display_type'));
			$html = '
			<div class="module_confirmation conf confirm alert alert-success">
			<button type="button" class="close" data-dismiss="alert">×</button>
			<ul class="list-unstyled">
			<li>Настройки сохранены</li>
			</ul>
			</div>';
			return $html;
		}
	}

	public
	function renderForm(){
		$this->fields_form[0]['form'] = array(
		'legend' => array(
				'title' => $this->l('Settings'),
				'icon' => 'icon-cog'
			),
		'input' => array(
			array(
				'type' => 'select',
				'label' => $this->l('Source'),
				'name' => 'display_type',
				'desc' => $this->l('Select source for parsing'),
				'options' => array(
					'query' => array(
						array(
							'id' => 0,
							'name' => 'nadavi.com.ua'
						),
						
						array(
							'id' => 2,
							'name' => 'torg.mail.ru'
						),
						
						array(
							'id' => 4,
							'name' => 'm.ua'
						)
					),
					'id' => 'id',
					'name' => 'name',
					)
				),
			),
		'submit' => array(
			'name' => 'submit_parcer',
			'title' => $this->l('Save')
			)
		);


		$helper = new HelperForm();
		$helper->module = $this;
		$helper->show_toolbar = false;
		$helper->table = $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'submit_parcer';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.
			'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);
		return $helper->generateForm($this->fields_form);
	}

	public
	function getConfigFieldsValues(){
		$fields_values = array();
		$fields_values['display_type'] = Configuration::get('PARSER');
		return $fields_values;
	}
}
